/* MainWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2024 Danielle Foré (https://github.com/danirabbit)
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <granite-7.h>
#include <glib/gi18n-lib.h>

#define MAIN_WINDOW_RESULTS_CSS "\n" \
"        @define-color colorForeground %s;\n" \
"        @define-color colorBackground %s;\n" \
"    "
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;

#define TYPE_GRADE_LABEL (grade_label_get_type ())
#define GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRADE_LABEL, GradeLabel))
#define GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRADE_LABEL, GradeLabelClass))
#define IS_GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRADE_LABEL))
#define IS_GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRADE_LABEL))
#define GRADE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRADE_LABEL, GradeLabelClass))

typedef struct _GradeLabel GradeLabel;
typedef struct _GradeLabelClass GradeLabelClass;
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
typedef struct _MainWindowOnEntryIconPressData MainWindowOnEntryIconPressData;

struct _MainWindow {
	GtkWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	GtkWindowClass parent_class;
};

struct _MainWindowPrivate {
	GdkRGBA gdk_color;
	GtkEntry* bg_entry;
	GtkEntry* fg_entry;
	GtkLabel* results_label;
	GradeLabel* a_level;
	GradeLabel* aa_level;
	GradeLabel* aaa_level;
};

struct _MainWindowOnEntryIconPressData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MainWindow* self;
	GtkEntry* entry;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkColorDialog* dialog;
	GtkColorDialog* _tmp2_;
	GdkRGBA* rgba;
	GdkRGBA _tmp3_;
	GdkRGBA* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_;
};

static gint MainWindow_private_offset;
static gpointer main_window_parent_class = NULL;

VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN GType grade_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GradeLabel, g_object_unref)
VALA_EXTERN MainWindow* main_window_new (GtkApplication* application);
VALA_EXTERN MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static void main_window_on_entry_icon_press_data_free (gpointer _data);
static void main_window_on_entry_icon_press (MainWindow* self,
                                      GtkEntry* entry,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void main_window_on_entry_icon_press_finish (MainWindow* self,
                                             GAsyncResult* _res_);
static gboolean main_window_on_entry_icon_press_co (MainWindowOnEntryIconPressData* _data_);
static void main_window_on_entry_icon_press_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void _vala_GdkRGBA_free (GdkRGBA* self);
static void main_window_on_entry_changed (MainWindow* self);
static void main_window_style_results_pane (MainWindow* self,
                                     const gchar* fg_color,
                                     const gchar* bg_color);
static gdouble main_window_get_luminance (MainWindow* self,
                                   GdkRGBA* color);
VALA_EXTERN void grade_label_set_pass (GradeLabel* self,
                           gboolean value);
static gdouble main_window_sanitize_color (MainWindow* self,
                                    gdouble color);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
VALA_EXTERN GradeLabel* grade_label_new (const gchar* level);
VALA_EXTERN GradeLabel* grade_label_construct (GType object_type,
                                   const gchar* level);
static void _main_window___lambda5_ (MainWindow* self,
                              GtkEntryIconPosition pos);
static void __main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    gpointer self);
static void _main_window_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                         gpointer self);
static void _main_window___lambda6_ (MainWindow* self,
                              GtkEntryIconPosition pos);
static void __main_window___lambda6__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    gpointer self);
static void _main_window___lambda7_ (MainWindow* self);
static void __main_window___lambda7__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self);
static void main_window_finalize (GObject * obj);
static GType main_window_get_type_once (void);

static inline gpointer
main_window_get_instance_private (MainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MainWindow_private_offset);
}

MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
#line 20 "../src/MainWindow.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 21 "../src/MainWindow.vala"
	self = (MainWindow*) g_object_new (object_type, "application", application, NULL);
#line 20 "../src/MainWindow.vala"
	return self;
#line 182 "MainWindow.c"
}

MainWindow*
main_window_new (GtkApplication* application)
{
#line 20 "../src/MainWindow.vala"
	return main_window_construct (TYPE_MAIN_WINDOW, application);
#line 190 "MainWindow.c"
}

static void
main_window_on_entry_icon_press_data_free (gpointer _data)
{
	MainWindowOnEntryIconPressData* _data_;
	_data_ = _data;
#line 6 "../src/MainWindow.vala"
	_g_object_unref0 (_data_->entry);
#line 6 "../src/MainWindow.vala"
	_g_object_unref0 (_data_->self);
#line 6 "../src/MainWindow.vala"
	g_slice_free (MainWindowOnEntryIconPressData, _data_);
#line 204 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 6 "../src/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 212 "MainWindow.c"
}

static void
main_window_on_entry_icon_press (MainWindow* self,
                                 GtkEntry* entry,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	MainWindowOnEntryIconPressData* _data_;
	MainWindow* _tmp0_;
	GtkEntry* _tmp1_;
#line 6 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 6 "../src/MainWindow.vala"
	g_return_if_fail (entry != NULL);
#line 6 "../src/MainWindow.vala"
	_data_ = g_slice_new0 (MainWindowOnEntryIconPressData);
#line 6 "../src/MainWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 6 "../src/MainWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, main_window_on_entry_icon_press_data_free);
#line 6 "../src/MainWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 6 "../src/MainWindow.vala"
	_data_->self = _tmp0_;
#line 6 "../src/MainWindow.vala"
	_tmp1_ = _g_object_ref0 (entry);
#line 6 "../src/MainWindow.vala"
	_g_object_unref0 (_data_->entry);
#line 6 "../src/MainWindow.vala"
	_data_->entry = _tmp1_;
#line 6 "../src/MainWindow.vala"
	main_window_on_entry_icon_press_co (_data_);
#line 246 "MainWindow.c"
}

static void
main_window_on_entry_icon_press_finish (MainWindow* self,
                                        GAsyncResult* _res_)
{
	MainWindowOnEntryIconPressData* _data_;
#line 6 "../src/MainWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 256 "MainWindow.c"
}

static void
main_window_on_entry_icon_press_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	MainWindowOnEntryIconPressData* _data_;
#line 162 "../src/MainWindow.vala"
	_data_ = _user_data_;
#line 162 "../src/MainWindow.vala"
	_data_->_source_object_ = source_object;
#line 162 "../src/MainWindow.vala"
	_data_->_res_ = _res_;
#line 162 "../src/MainWindow.vala"
	main_window_on_entry_icon_press_co (_data_);
#line 273 "MainWindow.c"
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
#line 161 "../src/MainWindow.vala"
	g_boxed_free (gdk_rgba_get_type (), self);
#line 281 "MainWindow.c"
}

static gboolean
main_window_on_entry_icon_press_co (MainWindowOnEntryIconPressData* _data_)
{
#line 153 "../src/MainWindow.vala"
	switch (_data_->_state_) {
#line 153 "../src/MainWindow.vala"
		case 0:
#line 291 "MainWindow.c"
		goto _state_0;
#line 153 "../src/MainWindow.vala"
		case 1:
#line 295 "MainWindow.c"
		goto _state_1;
		default:
#line 153 "../src/MainWindow.vala"
		g_assert_not_reached ();
#line 300 "MainWindow.c"
	}
	_state_0:
#line 154 "../src/MainWindow.vala"
	_data_->_tmp0_ = gtk_editable_get_text ((GtkEditable*) _data_->entry);
#line 154 "../src/MainWindow.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 154 "../src/MainWindow.vala"
	gdk_rgba_parse (&_data_->self->priv->gdk_color, _data_->_tmp1_);
#line 156 "../src/MainWindow.vala"
	_data_->_tmp2_ = NULL;
#line 156 "../src/MainWindow.vala"
	_data_->_tmp2_ = gtk_color_dialog_new ();
#line 156 "../src/MainWindow.vala"
	gtk_color_dialog_set_modal (_data_->_tmp2_, TRUE);
#line 156 "../src/MainWindow.vala"
	gtk_color_dialog_set_with_alpha (_data_->_tmp2_, FALSE);
#line 156 "../src/MainWindow.vala"
	_data_->dialog = _data_->_tmp2_;
#line 319 "MainWindow.c"
	{
#line 162 "../src/MainWindow.vala"
		_data_->_tmp3_ = _data_->self->priv->gdk_color;
#line 162 "../src/MainWindow.vala"
		_data_->_state_ = 1;
#line 162 "../src/MainWindow.vala"
		gtk_color_dialog_choose_rgba (_data_->dialog, (GtkWindow*) _data_->self, &_data_->_tmp3_, NULL, main_window_on_entry_icon_press_ready, _data_);
#line 162 "../src/MainWindow.vala"
		return FALSE;
#line 329 "MainWindow.c"
		_state_1:
#line 162 "../src/MainWindow.vala"
		_data_->_tmp4_ = gtk_color_dialog_choose_rgba_finish (_data_->dialog, _data_->_res_, &_data_->_inner_error0_);
#line 162 "../src/MainWindow.vala"
		_data_->rgba = _data_->_tmp4_;
#line 162 "../src/MainWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 337 "MainWindow.c"
			goto __catch0_g_error;
		}
#line 163 "../src/MainWindow.vala"
		_data_->_tmp5_ = gdk_rgba_to_string (_data_->rgba);
#line 163 "../src/MainWindow.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 163 "../src/MainWindow.vala"
		gtk_editable_set_text ((GtkEditable*) _data_->entry, _data_->_tmp6_);
#line 163 "../src/MainWindow.vala"
		_g_free0 (_data_->_tmp6_);
#line 161 "../src/MainWindow.vala"
		__vala_GdkRGBA_free0 (_data_->rgba);
#line 350 "MainWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 161 "../src/MainWindow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 165 "../src/MainWindow.vala"
		g_critical ("MainWindow.vala:165: failed to get color");
#line 359 "MainWindow.c"
	}
	__finally0:
#line 161 "../src/MainWindow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 161 "../src/MainWindow.vala"
		_g_object_unref0 (_data_->dialog);
#line 161 "../src/MainWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 161 "../src/MainWindow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 161 "../src/MainWindow.vala"
		g_object_unref (_data_->_async_result);
#line 161 "../src/MainWindow.vala"
		return FALSE;
#line 374 "MainWindow.c"
	}
#line 153 "../src/MainWindow.vala"
	_g_object_unref0 (_data_->dialog);
#line 153 "../src/MainWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 153 "../src/MainWindow.vala"
	if (_data_->_state_ != 0) {
#line 153 "../src/MainWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 153 "../src/MainWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 386 "MainWindow.c"
		}
	}
#line 153 "../src/MainWindow.vala"
	g_object_unref (_data_->_async_result);
#line 153 "../src/MainWindow.vala"
	return FALSE;
#line 393 "MainWindow.c"
}

static void
main_window_on_entry_changed (MainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 169 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/MainWindow.vala"
	_tmp1_ = self->priv->fg_entry;
#line 170 "../src/MainWindow.vala"
	_tmp2_ = gtk_editable_get_text ((GtkEditable*) _tmp1_);
#line 170 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 170 "../src/MainWindow.vala"
	_tmp4_ = strlen (_tmp3_);
#line 170 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 170 "../src/MainWindow.vala"
	if (_tmp5_ > 2) {
#line 419 "MainWindow.c"
		GtkEntry* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 170 "../src/MainWindow.vala"
		_tmp6_ = self->priv->bg_entry;
#line 170 "../src/MainWindow.vala"
		_tmp7_ = gtk_editable_get_text ((GtkEditable*) _tmp6_);
#line 170 "../src/MainWindow.vala"
		_tmp8_ = _tmp7_;
#line 170 "../src/MainWindow.vala"
		_tmp9_ = strlen (_tmp8_);
#line 170 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 170 "../src/MainWindow.vala"
		_tmp0_ = _tmp10_ > 2;
#line 437 "MainWindow.c"
	} else {
#line 170 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 441 "MainWindow.c"
	}
#line 170 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 445 "MainWindow.c"
		GtkEntry* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GtkEntry* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 171 "../src/MainWindow.vala"
		_tmp11_ = self->priv->fg_entry;
#line 171 "../src/MainWindow.vala"
		_tmp12_ = gtk_editable_get_text ((GtkEditable*) _tmp11_);
#line 171 "../src/MainWindow.vala"
		_tmp13_ = _tmp12_;
#line 171 "../src/MainWindow.vala"
		_tmp14_ = self->priv->bg_entry;
#line 171 "../src/MainWindow.vala"
		_tmp15_ = gtk_editable_get_text ((GtkEditable*) _tmp14_);
#line 171 "../src/MainWindow.vala"
		_tmp16_ = _tmp15_;
#line 171 "../src/MainWindow.vala"
		main_window_style_results_pane (self, _tmp13_, _tmp16_);
#line 466 "MainWindow.c"
	}
}

static void
main_window_style_results_pane (MainWindow* self,
                                const gchar* fg_color,
                                const gchar* bg_color)
{
	gchar* colored_css = NULL;
	gchar* _tmp0_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	const gchar* _tmp3_;
	GdkDisplay* _tmp4_;
	GtkCssProvider* _tmp5_;
	gdouble pango_fg_luminance = 0.0;
	GdkRGBA _tmp6_;
	gdouble pango_bg_luminance = 0.0;
	GdkRGBA _tmp7_;
	gdouble contrast_ratio = 0.0;
	GtkLabel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 175 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/MainWindow.vala"
	g_return_if_fail (fg_color != NULL);
#line 175 "../src/MainWindow.vala"
	g_return_if_fail (bg_color != NULL);
#line 176 "../src/MainWindow.vala"
	_tmp0_ = g_strdup_printf (MAIN_WINDOW_RESULTS_CSS, fg_color, bg_color);
#line 176 "../src/MainWindow.vala"
	colored_css = _tmp0_;
#line 178 "../src/MainWindow.vala"
	_tmp1_ = gtk_css_provider_new ();
#line 178 "../src/MainWindow.vala"
	provider = _tmp1_;
#line 179 "../src/MainWindow.vala"
	_tmp2_ = provider;
#line 179 "../src/MainWindow.vala"
	_tmp3_ = colored_css;
#line 179 "../src/MainWindow.vala"
	gtk_css_provider_load_from_string (_tmp2_, _tmp3_);
#line 181 "../src/MainWindow.vala"
	_tmp4_ = gdk_display_get_default ();
#line 181 "../src/MainWindow.vala"
	_tmp5_ = provider;
#line 181 "../src/MainWindow.vala"
	gtk_style_context_add_provider_for_display (_tmp4_, (GtkStyleProvider*) _tmp5_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 183 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, fg_color);
#line 184 "../src/MainWindow.vala"
	_tmp6_ = self->priv->gdk_color;
#line 184 "../src/MainWindow.vala"
	pango_fg_luminance = main_window_get_luminance (self, &_tmp6_);
#line 186 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, bg_color);
#line 187 "../src/MainWindow.vala"
	_tmp7_ = self->priv->gdk_color;
#line 187 "../src/MainWindow.vala"
	pango_bg_luminance = main_window_get_luminance (self, &_tmp7_);
#line 191 "../src/MainWindow.vala"
	if (pango_bg_luminance > pango_fg_luminance) {
#line 192 "../src/MainWindow.vala"
		contrast_ratio = (pango_bg_luminance + 0.05) / (pango_fg_luminance + 0.05);
#line 533 "MainWindow.c"
	} else {
#line 194 "../src/MainWindow.vala"
		contrast_ratio = (pango_fg_luminance + 0.05) / (pango_bg_luminance + 0.05);
#line 537 "MainWindow.c"
	}
#line 197 "../src/MainWindow.vala"
	_tmp8_ = self->priv->results_label;
#line 197 "../src/MainWindow.vala"
	_tmp9_ = g_strdup_printf ("%.1f:1", contrast_ratio);
#line 197 "../src/MainWindow.vala"
	_tmp10_ = _tmp9_;
#line 197 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp8_, _tmp10_);
#line 197 "../src/MainWindow.vala"
	_g_free0 (_tmp10_);
#line 199 "../src/MainWindow.vala"
	if (contrast_ratio >= ((gdouble) 3)) {
#line 551 "MainWindow.c"
		GradeLabel* _tmp11_;
#line 200 "../src/MainWindow.vala"
		_tmp11_ = self->priv->a_level;
#line 200 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp11_, TRUE);
#line 557 "MainWindow.c"
	} else {
		GradeLabel* _tmp12_;
#line 202 "../src/MainWindow.vala"
		_tmp12_ = self->priv->a_level;
#line 202 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp12_, FALSE);
#line 564 "MainWindow.c"
	}
#line 205 "../src/MainWindow.vala"
	if (contrast_ratio >= 4.5) {
#line 568 "MainWindow.c"
		GradeLabel* _tmp13_;
#line 206 "../src/MainWindow.vala"
		_tmp13_ = self->priv->aa_level;
#line 206 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp13_, TRUE);
#line 574 "MainWindow.c"
	} else {
		GradeLabel* _tmp14_;
#line 208 "../src/MainWindow.vala"
		_tmp14_ = self->priv->aa_level;
#line 208 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp14_, FALSE);
#line 581 "MainWindow.c"
	}
#line 211 "../src/MainWindow.vala"
	if (contrast_ratio >= ((gdouble) 7)) {
#line 585 "MainWindow.c"
		GradeLabel* _tmp15_;
#line 212 "../src/MainWindow.vala"
		_tmp15_ = self->priv->aaa_level;
#line 212 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp15_, TRUE);
#line 591 "MainWindow.c"
	} else {
		GradeLabel* _tmp16_;
#line 214 "../src/MainWindow.vala"
		_tmp16_ = self->priv->aaa_level;
#line 214 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp16_, FALSE);
#line 598 "MainWindow.c"
	}
#line 175 "../src/MainWindow.vala"
	_g_object_unref0 (provider);
#line 175 "../src/MainWindow.vala"
	_g_free0 (colored_css);
#line 604 "MainWindow.c"
}

static gdouble
main_window_get_luminance (MainWindow* self,
                           GdkRGBA* color)
{
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble green = 0.0;
	GdkRGBA _tmp1_;
	gdouble blue = 0.0;
	GdkRGBA _tmp2_;
	gdouble result;
#line 218 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 218 "../src/MainWindow.vala"
	g_return_val_if_fail (color != NULL, 0.0);
#line 219 "../src/MainWindow.vala"
	_tmp0_ = *color;
#line 219 "../src/MainWindow.vala"
	red = main_window_sanitize_color (self, (gdouble) _tmp0_.red) * 0.2126;
#line 220 "../src/MainWindow.vala"
	_tmp1_ = *color;
#line 220 "../src/MainWindow.vala"
	green = main_window_sanitize_color (self, (gdouble) _tmp1_.green) * 0.7152;
#line 221 "../src/MainWindow.vala"
	_tmp2_ = *color;
#line 221 "../src/MainWindow.vala"
	blue = main_window_sanitize_color (self, (gdouble) _tmp2_.blue) * 0.0722;
#line 223 "../src/MainWindow.vala"
	result = (red + green) + blue;
#line 223 "../src/MainWindow.vala"
	return result;
#line 638 "MainWindow.c"
}

static gdouble
main_window_sanitize_color (MainWindow* self,
                            gdouble color)
{
	gdouble result;
#line 226 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 227 "../src/MainWindow.vala"
	if (color <= 0.03928) {
#line 228 "../src/MainWindow.vala"
		color = color / 12.92;
#line 652 "MainWindow.c"
	} else {
#line 230 "../src/MainWindow.vala"
		color = pow ((color + 0.055) / 1.055, 2.4);
#line 656 "MainWindow.c"
	}
#line 232 "../src/MainWindow.vala"
	result = color;
#line 232 "../src/MainWindow.vala"
	return result;
#line 662 "MainWindow.c"
}

static void
_main_window___lambda5_ (MainWindow* self,
                         GtkEntryIconPosition pos)
{
#line 123 "../src/MainWindow.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 671 "MainWindow.c"
		GtkEntry* _tmp0_;
#line 124 "../src/MainWindow.vala"
		_tmp0_ = self->priv->fg_entry;
#line 124 "../src/MainWindow.vala"
		main_window_on_entry_icon_press (self, _tmp0_, NULL, NULL);
#line 677 "MainWindow.c"
	}
}

static void
__main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               gpointer self)
{
#line 122 "../src/MainWindow.vala"
	_main_window___lambda5_ ((MainWindow*) self, icon_pos);
#line 688 "MainWindow.c"
}

static void
_main_window_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self)
{
#line 128 "../src/MainWindow.vala"
	main_window_on_entry_changed ((MainWindow*) self);
#line 697 "MainWindow.c"
}

static void
_main_window___lambda6_ (MainWindow* self,
                         GtkEntryIconPosition pos)
{
#line 131 "../src/MainWindow.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 706 "MainWindow.c"
		GtkEntry* _tmp0_;
#line 132 "../src/MainWindow.vala"
		_tmp0_ = self->priv->bg_entry;
#line 132 "../src/MainWindow.vala"
		main_window_on_entry_icon_press (self, _tmp0_, NULL, NULL);
#line 712 "MainWindow.c"
	}
}

static void
__main_window___lambda6__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               gpointer self)
{
#line 130 "../src/MainWindow.vala"
	_main_window___lambda6_ ((MainWindow*) self, icon_pos);
#line 723 "MainWindow.c"
}

static void
_main_window___lambda7_ (MainWindow* self)
{
	gchar* fg_text = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* bg_text = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GtkEntry* _tmp8_;
	const gchar* _tmp9_;
	GtkEntry* _tmp10_;
	const gchar* _tmp11_;
#line 139 "../src/MainWindow.vala"
	_tmp0_ = self->priv->fg_entry;
#line 139 "../src/MainWindow.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 139 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 139 "../src/MainWindow.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 139 "../src/MainWindow.vala"
	fg_text = _tmp3_;
#line 140 "../src/MainWindow.vala"
	_tmp4_ = self->priv->bg_entry;
#line 140 "../src/MainWindow.vala"
	_tmp5_ = gtk_editable_get_text ((GtkEditable*) _tmp4_);
#line 140 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 140 "../src/MainWindow.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 140 "../src/MainWindow.vala"
	bg_text = _tmp7_;
#line 142 "../src/MainWindow.vala"
	_tmp8_ = self->priv->fg_entry;
#line 142 "../src/MainWindow.vala"
	_tmp9_ = bg_text;
#line 142 "../src/MainWindow.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp8_, _tmp9_);
#line 143 "../src/MainWindow.vala"
	_tmp10_ = self->priv->bg_entry;
#line 143 "../src/MainWindow.vala"
	_tmp11_ = fg_text;
#line 143 "../src/MainWindow.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp10_, _tmp11_);
#line 138 "../src/MainWindow.vala"
	_g_free0 (bg_text);
#line 138 "../src/MainWindow.vala"
	_g_free0 (fg_text);
#line 779 "MainWindow.c"
}

static void
__main_window___lambda7__gtk_button_clicked (GtkButton* _sender,
                                             gpointer self)
{
#line 138 "../src/MainWindow.vala"
	_main_window___lambda7_ ((MainWindow*) self);
#line 788 "MainWindow.c"
}

static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GraniteHeaderLabel* fg_label = NULL;
	GraniteHeaderLabel* _tmp0_;
	GraniteHeaderLabel* bg_label = NULL;
	GraniteHeaderLabel* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkEntry* _tmp4_ = NULL;
	GtkButton* swap_button = NULL;
	gchar* _tmp5_;
	GtkButton* _tmp6_ = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkEntry* _tmp9_ = NULL;
	GtkBox* fg_box = NULL;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GraniteHeaderLabel* _tmp12_;
	GtkBox* _tmp13_;
	GtkEntry* _tmp14_;
	GtkBox* bg_box = NULL;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GraniteHeaderLabel* _tmp17_;
	GtkBox* _tmp18_;
	GtkEntry* _tmp19_;
	GtkBox* inputs_box = NULL;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkButton* _tmp25_;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
	GtkLabel* _tmp28_ = NULL;
	GtkLabel* _tmp29_;
	gchar* _tmp30_;
	GradeLabel* _tmp31_ = NULL;
	gchar* _tmp32_;
	GradeLabel* _tmp33_ = NULL;
	gchar* _tmp34_;
	GradeLabel* _tmp35_ = NULL;
	GtkBox* levels_box = NULL;
	GtkBox* _tmp36_ = NULL;
	GtkBox* _tmp37_;
	GradeLabel* _tmp38_;
	GtkBox* _tmp39_;
	GradeLabel* _tmp40_;
	GtkBox* _tmp41_;
	GradeLabel* _tmp42_;
	GtkBox* results_box = NULL;
	GtkBox* _tmp43_;
	GtkBox* _tmp44_;
	GtkBox* _tmp45_;
	GtkLabel* _tmp46_;
	GtkBox* _tmp47_;
	GtkBox* _tmp48_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp49_;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GtkBox* _tmp52_;
	GtkBox* _tmp53_;
	GtkWindowHandle* window_handle = NULL;
	GtkBox* _tmp54_;
	GtkWidget* _tmp55_;
	GtkWindowHandle* _tmp56_ = NULL;
	GtkGrid* _tmp57_ = NULL;
	GtkHeaderBar* _tmp58_ = NULL;
	GtkHeaderBar* _tmp59_;
	GtkWidget* _tmp60_;
	GtkWidget* _tmp61_;
	GtkWindowHandle* _tmp62_;
	GtkEntry* _tmp63_;
	GtkEntry* _tmp64_;
	GtkEntry* _tmp65_;
	GtkEntry* _tmp66_;
	GtkButton* _tmp67_;
	GSettings* settings = NULL;
	GSettings* _tmp68_;
	GSettings* _tmp69_;
	GtkEntry* _tmp70_;
	GSettings* _tmp71_;
	GtkEntry* _tmp72_;
	GtkEntry* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	GtkEntry* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
#line 24 "../src/MainWindow.vala"
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
#line 24 "../src/MainWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 24 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 25 "../src/MainWindow.vala"
	_tmp0_ = granite_header_label_new (_ ("Foreground Color"));
#line 25 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 25 "../src/MainWindow.vala"
	fg_label = _tmp0_;
#line 27 "../src/MainWindow.vala"
	_tmp1_ = granite_header_label_new (_ ("Background Color"));
#line 27 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 27 "../src/MainWindow.vala"
	bg_label = _tmp1_;
#line 29 "../src/MainWindow.vala"
	_tmp2_ = g_strdup ("#333");
#line 29 "../src/MainWindow.vala"
	_tmp3_ = g_strdup ("media-eq-symbolic");
#line 29 "../src/MainWindow.vala"
	_tmp4_ = (GtkEntry*) gtk_entry_new ();
#line 29 "../src/MainWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp4_, TRUE);
#line 29 "../src/MainWindow.vala"
	gtk_entry_set_placeholder_text (_tmp4_, _tmp2_);
#line 29 "../src/MainWindow.vala"
	_g_free0 (_tmp2_);
#line 29 "../src/MainWindow.vala"
	g_object_set (_tmp4_, "secondary-icon-name", _tmp3_, NULL);
#line 29 "../src/MainWindow.vala"
	_g_free0 (_tmp3_);
#line 29 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 29 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->fg_entry);
#line 29 "../src/MainWindow.vala"
	self->priv->fg_entry = _tmp4_;
#line 35 "../src/MainWindow.vala"
	_tmp5_ = g_strdup (_ ("Swap foreground and background colors"));
#line 35 "../src/MainWindow.vala"
	_tmp6_ = (GtkButton*) gtk_button_new_from_icon_name ("object-flip-horizontal-symbolic");
#line 35 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _tmp5_);
#line 35 "../src/MainWindow.vala"
	_g_free0 (_tmp5_);
#line 35 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
#line 35 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 35 "../src/MainWindow.vala"
	swap_button = _tmp6_;
#line 40 "../src/MainWindow.vala"
	_tmp7_ = g_strdup ("rgb (110, 200, 230)");
#line 40 "../src/MainWindow.vala"
	_tmp8_ = g_strdup ("media-eq-symbolic");
#line 40 "../src/MainWindow.vala"
	_tmp9_ = (GtkEntry*) gtk_entry_new ();
#line 40 "../src/MainWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
#line 40 "../src/MainWindow.vala"
	gtk_entry_set_placeholder_text (_tmp9_, _tmp7_);
#line 40 "../src/MainWindow.vala"
	_g_free0 (_tmp7_);
#line 40 "../src/MainWindow.vala"
	g_object_set (_tmp9_, "secondary-icon-name", _tmp8_, NULL);
#line 40 "../src/MainWindow.vala"
	_g_free0 (_tmp8_);
#line 40 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 40 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->bg_entry);
#line 40 "../src/MainWindow.vala"
	self->priv->bg_entry = _tmp9_;
#line 46 "../src/MainWindow.vala"
	_tmp10_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 46 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp10_);
#line 46 "../src/MainWindow.vala"
	fg_box = _tmp10_;
#line 47 "../src/MainWindow.vala"
	_tmp11_ = fg_box;
#line 47 "../src/MainWindow.vala"
	_tmp12_ = fg_label;
#line 47 "../src/MainWindow.vala"
	gtk_box_append (_tmp11_, (GtkWidget*) _tmp12_);
#line 48 "../src/MainWindow.vala"
	_tmp13_ = fg_box;
#line 48 "../src/MainWindow.vala"
	_tmp14_ = self->priv->fg_entry;
#line 48 "../src/MainWindow.vala"
	gtk_box_append (_tmp13_, (GtkWidget*) _tmp14_);
#line 50 "../src/MainWindow.vala"
	_tmp15_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 50 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 50 "../src/MainWindow.vala"
	bg_box = _tmp15_;
#line 51 "../src/MainWindow.vala"
	_tmp16_ = bg_box;
#line 51 "../src/MainWindow.vala"
	_tmp17_ = bg_label;
#line 51 "../src/MainWindow.vala"
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
#line 52 "../src/MainWindow.vala"
	_tmp18_ = bg_box;
#line 52 "../src/MainWindow.vala"
	_tmp19_ = self->priv->bg_entry;
#line 52 "../src/MainWindow.vala"
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
#line 54 "../src/MainWindow.vala"
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 54 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp20_);
#line 54 "../src/MainWindow.vala"
	inputs_box = _tmp20_;
#line 55 "../src/MainWindow.vala"
	_tmp21_ = inputs_box;
#line 55 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp21_, "inputs");
#line 56 "../src/MainWindow.vala"
	_tmp22_ = inputs_box;
#line 56 "../src/MainWindow.vala"
	_tmp23_ = fg_box;
#line 56 "../src/MainWindow.vala"
	gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 57 "../src/MainWindow.vala"
	_tmp24_ = inputs_box;
#line 57 "../src/MainWindow.vala"
	_tmp25_ = swap_button;
#line 57 "../src/MainWindow.vala"
	gtk_box_append (_tmp24_, (GtkWidget*) _tmp25_);
#line 58 "../src/MainWindow.vala"
	_tmp26_ = inputs_box;
#line 58 "../src/MainWindow.vala"
	_tmp27_ = bg_box;
#line 58 "../src/MainWindow.vala"
	gtk_box_append (_tmp26_, (GtkWidget*) _tmp27_);
#line 60 "../src/MainWindow.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new ("12:1");
#line 60 "../src/MainWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp28_, TRUE);
#line 60 "../src/MainWindow.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp28_, TRUE);
#line 60 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp28_, TRUE);
#line 60 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
#line 60 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
#line 60 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp28_);
#line 60 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->results_label);
#line 60 "../src/MainWindow.vala"
	self->priv->results_label = _tmp28_;
#line 67 "../src/MainWindow.vala"
	_tmp29_ = self->priv->results_label;
#line 67 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp29_, GRANITE_STYLE_CLASS_H1_LABEL);
#line 69 "../src/MainWindow.vala"
	_tmp30_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("3:1"), _ ("The minimum level recommended by ISO-9241-3 and ANSI-HFES-100-1988 for" \
" standard text and vision"));
#line 69 "../src/MainWindow.vala"
	_tmp31_ = grade_label_new ("WCAG A");
#line 69 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp31_, _tmp30_);
#line 69 "../src/MainWindow.vala"
	_g_free0 (_tmp30_);
#line 69 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp31_);
#line 69 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->a_level);
#line 69 "../src/MainWindow.vala"
	self->priv->a_level = _tmp31_;
#line 76 "../src/MainWindow.vala"
	_tmp32_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("4.5:1"), _ ("Compensates for the loss in contrast that results from moderately low " \
"visual acuity, color deficiencies, or aging."));
#line 76 "../src/MainWindow.vala"
	_tmp33_ = grade_label_new ("WCAG AA");
#line 76 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp33_, _tmp32_);
#line 76 "../src/MainWindow.vala"
	_g_free0 (_tmp32_);
#line 76 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp33_);
#line 76 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aa_level);
#line 76 "../src/MainWindow.vala"
	self->priv->aa_level = _tmp33_;
#line 83 "../src/MainWindow.vala"
	_tmp34_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("7:1"), _ ("Compensates for the loss in contrast sensitivity usually experienced b" \
"y users with about 20/80 vision. People with more than this degree of " \
"vision loss usually use assistive technologies."));
#line 83 "../src/MainWindow.vala"
	_tmp35_ = grade_label_new ("WCAG AAA");
#line 83 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp35_, _tmp34_);
#line 83 "../src/MainWindow.vala"
	_g_free0 (_tmp34_);
#line 83 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp35_);
#line 83 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aaa_level);
#line 83 "../src/MainWindow.vala"
	self->priv->aaa_level = _tmp35_;
#line 90 "../src/MainWindow.vala"
	_tmp36_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 90 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp36_, GTK_ALIGN_CENTER);
#line 90 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp36_);
#line 90 "../src/MainWindow.vala"
	levels_box = _tmp36_;
#line 93 "../src/MainWindow.vala"
	_tmp37_ = levels_box;
#line 93 "../src/MainWindow.vala"
	_tmp38_ = self->priv->a_level;
#line 93 "../src/MainWindow.vala"
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 94 "../src/MainWindow.vala"
	_tmp39_ = levels_box;
#line 94 "../src/MainWindow.vala"
	_tmp40_ = self->priv->aa_level;
#line 94 "../src/MainWindow.vala"
	gtk_box_append (_tmp39_, (GtkWidget*) _tmp40_);
#line 95 "../src/MainWindow.vala"
	_tmp41_ = levels_box;
#line 95 "../src/MainWindow.vala"
	_tmp42_ = self->priv->aaa_level;
#line 95 "../src/MainWindow.vala"
	gtk_box_append (_tmp41_, (GtkWidget*) _tmp42_);
#line 97 "../src/MainWindow.vala"
	_tmp43_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 97 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp43_);
#line 97 "../src/MainWindow.vala"
	results_box = _tmp43_;
#line 98 "../src/MainWindow.vala"
	_tmp44_ = results_box;
#line 98 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp44_, "results");
#line 99 "../src/MainWindow.vala"
	_tmp45_ = results_box;
#line 99 "../src/MainWindow.vala"
	_tmp46_ = self->priv->results_label;
#line 99 "../src/MainWindow.vala"
	gtk_box_append (_tmp45_, (GtkWidget*) _tmp46_);
#line 100 "../src/MainWindow.vala"
	_tmp47_ = results_box;
#line 100 "../src/MainWindow.vala"
	_tmp48_ = levels_box;
#line 100 "../src/MainWindow.vala"
	gtk_box_append (_tmp47_, (GtkWidget*) _tmp48_);
#line 102 "../src/MainWindow.vala"
	_tmp49_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 102 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp49_);
#line 102 "../src/MainWindow.vala"
	main_box = _tmp49_;
#line 103 "../src/MainWindow.vala"
	_tmp50_ = main_box;
#line 103 "../src/MainWindow.vala"
	_tmp51_ = inputs_box;
#line 103 "../src/MainWindow.vala"
	gtk_box_append (_tmp50_, (GtkWidget*) _tmp51_);
#line 104 "../src/MainWindow.vala"
	_tmp52_ = main_box;
#line 104 "../src/MainWindow.vala"
	_tmp53_ = results_box;
#line 104 "../src/MainWindow.vala"
	gtk_box_append (_tmp52_, (GtkWidget*) _tmp53_);
#line 106 "../src/MainWindow.vala"
	_tmp54_ = main_box;
#line 106 "../src/MainWindow.vala"
	_tmp55_ = _g_object_ref0 ((GtkWidget*) _tmp54_);
#line 106 "../src/MainWindow.vala"
	_tmp56_ = (GtkWindowHandle*) gtk_window_handle_new ();
#line 106 "../src/MainWindow.vala"
	gtk_window_handle_set_child (_tmp56_, _tmp55_);
#line 106 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp55_);
#line 106 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp56_);
#line 106 "../src/MainWindow.vala"
	window_handle = _tmp56_;
#line 110 "../src/MainWindow.vala"
	_tmp57_ = (GtkGrid*) gtk_grid_new ();
#line 110 "../src/MainWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp57_, FALSE);
#line 110 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp57_);
#line 110 "../src/MainWindow.vala"
	_tmp58_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 110 "../src/MainWindow.vala"
	gtk_header_bar_set_show_title_buttons (_tmp58_, TRUE);
#line 110 "../src/MainWindow.vala"
	gtk_header_bar_set_title_widget (_tmp58_, (GtkWidget*) _tmp57_);
#line 110 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp57_);
#line 110 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp58_);
#line 110 "../src/MainWindow.vala"
	_tmp59_ = _tmp58_;
#line 110 "../src/MainWindow.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp59_);
#line 110 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp59_);
#line 114 "../src/MainWindow.vala"
	_tmp60_ = gtk_window_get_titlebar ((GtkWindow*) self);
#line 114 "../src/MainWindow.vala"
	_tmp61_ = _tmp60_;
#line 114 "../src/MainWindow.vala"
	gtk_widget_add_css_class (_tmp61_, GRANITE_STYLE_CLASS_FLAT);
#line 116 "../src/MainWindow.vala"
	_tmp62_ = window_handle;
#line 116 "../src/MainWindow.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp62_);
#line 117 "../src/MainWindow.vala"
	g_object_set ((GtkWindow*) self, "default-height", 300, NULL);
#line 118 "../src/MainWindow.vala"
	g_object_set ((GtkWindow*) self, "default-width", 400, NULL);
#line 119 "../src/MainWindow.vala"
	gtk_window_set_icon_name ((GtkWindow*) self, "io.github.danirabbit.harvey");
#line 120 "../src/MainWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Harvey"));
#line 122 "../src/MainWindow.vala"
	_tmp63_ = self->priv->fg_entry;
#line 122 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp63_, "icon-press", (GCallback) __main_window___lambda5__gtk_entry_icon_press, self, 0);
#line 128 "../src/MainWindow.vala"
	_tmp64_ = self->priv->fg_entry;
#line 128 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp64_, "changed", (GCallback) _main_window_on_entry_changed_gtk_editable_changed, self, 0);
#line 130 "../src/MainWindow.vala"
	_tmp65_ = self->priv->bg_entry;
#line 130 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp65_, "icon-press", (GCallback) __main_window___lambda6__gtk_entry_icon_press, self, 0);
#line 136 "../src/MainWindow.vala"
	_tmp66_ = self->priv->bg_entry;
#line 136 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp66_, "changed", (GCallback) _main_window_on_entry_changed_gtk_editable_changed, self, 0);
#line 138 "../src/MainWindow.vala"
	_tmp67_ = swap_button;
#line 138 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp67_, "clicked", (GCallback) __main_window___lambda7__gtk_button_clicked, self, 0);
#line 146 "../src/MainWindow.vala"
	_tmp68_ = g_settings_new ("io.github.danirabbit.harvey");
#line 146 "../src/MainWindow.vala"
	settings = _tmp68_;
#line 147 "../src/MainWindow.vala"
	_tmp69_ = settings;
#line 147 "../src/MainWindow.vala"
	_tmp70_ = self->priv->fg_entry;
#line 147 "../src/MainWindow.vala"
	g_settings_bind (_tmp69_, "fg-color", (GObject*) _tmp70_, "text", G_SETTINGS_BIND_DEFAULT);
#line 148 "../src/MainWindow.vala"
	_tmp71_ = settings;
#line 148 "../src/MainWindow.vala"
	_tmp72_ = self->priv->bg_entry;
#line 148 "../src/MainWindow.vala"
	g_settings_bind (_tmp71_, "bg-color", (GObject*) _tmp72_, "text", G_SETTINGS_BIND_DEFAULT);
#line 150 "../src/MainWindow.vala"
	_tmp73_ = self->priv->fg_entry;
#line 150 "../src/MainWindow.vala"
	_tmp74_ = gtk_editable_get_text ((GtkEditable*) _tmp73_);
#line 150 "../src/MainWindow.vala"
	_tmp75_ = _tmp74_;
#line 150 "../src/MainWindow.vala"
	_tmp76_ = self->priv->bg_entry;
#line 150 "../src/MainWindow.vala"
	_tmp77_ = gtk_editable_get_text ((GtkEditable*) _tmp76_);
#line 150 "../src/MainWindow.vala"
	_tmp78_ = _tmp77_;
#line 150 "../src/MainWindow.vala"
	main_window_style_results_pane (self, _tmp75_, _tmp78_);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (settings);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (window_handle);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (main_box);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (results_box);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (levels_box);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (inputs_box);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (bg_box);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (fg_box);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (swap_button);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (bg_label);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (fg_label);
#line 24 "../src/MainWindow.vala"
	return obj;
#line 1287 "MainWindow.c"
}

static void
main_window_class_init (MainWindowClass * klass,
                        gpointer klass_data)
{
#line 6 "../src/MainWindow.vala"
	main_window_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &MainWindow_private_offset);
#line 6 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
#line 6 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
#line 1302 "MainWindow.c"
}

static void
main_window_instance_init (MainWindow * self,
                           gpointer klass)
{
#line 6 "../src/MainWindow.vala"
	self->priv = main_window_get_instance_private (self);
#line 1311 "MainWindow.c"
}

static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
#line 6 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 13 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->bg_entry);
#line 14 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->fg_entry);
#line 15 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->results_label);
#line 16 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->a_level);
#line 17 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aa_level);
#line 18 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aaa_level);
#line 6 "../src/MainWindow.vala"
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
#line 1334 "MainWindow.c"
}

static GType
main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
	GType main_window_type_id;
	main_window_type_id = g_type_register_static (gtk_window_get_type (), "MainWindow", &g_define_type_info, 0);
	MainWindow_private_offset = g_type_add_instance_private (main_window_type_id, sizeof (MainWindowPrivate));
	return main_window_type_id;
}

GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__once = 0;
	if (g_once_init_enter (&main_window_type_id__once)) {
		GType main_window_type_id;
		main_window_type_id = main_window_get_type_once ();
		g_once_init_leave (&main_window_type_id__once, main_window_type_id);
	}
	return main_window_type_id__once;
}

